
#include <stdio.h>
#include "dictionary.h"
#include "astring.h"

static void 
TestAssociation()
{
	String name1("William");
	String name2("Albert");
	String name3("Adams");

	association<String , double> assoc1(name1, 10.0);
	association<String , double> assoc2(name2, 20.0);
	association<String , double> assoc3(name3, 30.0);
	
	printf("Association1: %s  Value: %f\n", (const char *)assoc1.Key(), assoc1.Value());
	printf("Association2: %s  Value: %f\n", (const char *)assoc2.Key(), assoc2.Value());
	printf("Association3: %s  Value: %f\n", (const char *)assoc3.Key(), assoc3.Value());

	printf("assoc1 == assoc2 (%d)\n", assoc1.Key() == assoc2.Key());

	assoc2 = assoc1;

	printf("assoc1 == assoc2 (%d)\n", assoc1.Key() == assoc2.Key());
}


static void
TestDictionary()
{
	dictionary<String, double> data(0.0);
	
	String name1("William");
	String name2("Albert");
	String name3("Adams");
	
	printf("Includes William: %d\n", data.Includes(name1));
	
	data[name1] = 10.0;

	printf("Includes William: %d\n", data.Includes(name1));
	data[name2] = 20.0;
	data[name3] = 30.0;

	dictionaryIterator<String, double> itr(data);
	for (itr.init(); !itr.done(); itr.next())
	{
		printf("Key: %s Value: %f\n", (const char *)itr()->Key(), itr()->Value());
	}
}

main()
{
	TestAssociation();
	TestDictionary();
}
