
#include <stdio.h>
#include "sort.h"
#include "vector.h"
#include "vectoriterator.h"
#include "random.h"
#include <StopWatch.h>

const long size = 10000;

static void 
TestBubbleSort()
{
	//printf("\n\nSorting using: %s\n\n", "BubbleSort");

	// Create a huge array of integers
	vector<int> aVector(size);

	// Fill it with random numbers
	Random rnd;
	for (int i=0; i<size; i++)
		aVector[i] = rnd.Between(1,size);

	{
		BStopWatch watcher("BubbleTime");
		BubbleSort(aVector);
	}
}

static void 
TestSelectionSort()
{
	//printf("\n\nSorting using: %s\n\n", "SelectionSort");

	// Create a huge array of integers
	vector<int> aVector(size);

	// Fill it with random numbers
	Random rnd;
	for (int i=0; i<size; i++)
		aVector[i] = rnd.Between(1,size);

	{
		BStopWatch watcher("SelectionTime");
		SelectionSort(aVector);
	}
}

static void 
TestInsertionSort()
{
	//printf("\n\nSorting using: %s\n\n", "InsertionSort");

	// Create a huge array of integers
	vector<int> aVector(size);

	// Fill it with random numbers
	Random rnd;
	for (int i=0; i<size; i++)
		aVector[i] = rnd.Between(1,size);

	{
		BStopWatch watcher("InsertionTime");
		InsertionSort(aVector);
	}
}

static void 
TestQuickSort()
{
	//printf("\n\nSorting using: %s\n\n", "QuickSort");

	// Create a huge array of integers
	vector<int> aVector(size);

	// Fill it with random numbers
	Random rnd;
	for (int i=0; i<size; i++)
		aVector[i] = rnd.Between(1,size);

	{
		BStopWatch watcher("QuickTime");
		QuickSort(aVector);
	}
}

static void 
TestHeapSort()
{
	//printf("\n\nSorting using: %s\n\n", "HeapSort");

	// Create a huge array of integers
	vector<int> aVector(size);

	// Fill it with random numbers
	Random rnd;
	for (int i=0; i<size; i++)
		aVector[i] = rnd.Between(1,size);

	// Iterate over the list printing out items
	//printf("Before sorting\n");
	//vectorIterator<int> itr(aVector);
	//for (itr.init(); !itr.done(); itr.next())
	//{
	//	printf("Value: %d\n", itr());	
	//}

	//printf("\n\nAfter Sort\n");
	// Do the sort
	{
		BStopWatch watcher("HeapTime");
		HeapSort(aVector);
	}
	// Print the results
	//vectorIterator<int> itr2(aVector);
	//for (itr2.init(); !itr2.done(); itr2.next())
	//{
	//	printf("%d\n", itr2());	
	//}

}

main()
{
	TestBubbleSort();
	TestSelectionSort();
	TestInsertionSort();
	TestQuickSort();
	TestHeapSort();
}
