
#include <stdio.h>

#include "binarynode.h"
#include "treetraverse.h"


static void
TestNodes()
{
	binaryNode<long> *node = new binaryNode<long>(2);
	binaryNode<long> *lnode = new binaryNode<long>(1);
	binaryNode<long> *rnode = new binaryNode<long>(3);
	
	node->SetLeft(lnode);
	node->SetRight(rnode);
	
	// do a preorder traversal
	printf("Postorder Traversal\n");
	postorderTraversal<long> itr1(node);
	for (itr1.init(); !itr1.done(); itr1.next())
		printf("  %d\n", itr1());
		
	// do a postorder traversal
	printf("Preorder Traversal\n");
	preorderTraversal<long> itr2(node);
	for (itr2.init(); !itr2.done(); itr2.next())
		printf("  %d\n", itr2());

	// do a inorder traversal
	printf("Inorder Traversal\n");
	inorderTraversal<long> itr3(node);
	for (itr3.init(); !itr3.done(); itr3.next())
		printf("  %d\n", itr3());
}

main()
{
	TestNodes();
}
