#ifndef BITVECTOR_H
#define BITVECTOR_H

#include "vector.h"

class bitVector
{
public:
			bitVector(unsigned int nElements);
			bitVector(const bitVector& other);
			
			unsigned long Length() const;
				// Bit changing operations
	virtual	void	Set(unsigned long idx);
	virtual	void	Clear(unsigned long idx);
	virtual	bool	IsSet(unsigned long idx) const;
	virtual	void	Flip(unsigned long idx);
	
	// Set Operations
	virtual	void	Add(const bitVector& other);				// operator |=
	virtual	void	Subtract(const bitVector& other);		// operator &= ~
	virtual	void	IntersectWith(const bitVector& other);	//	operator &=
	virtual	bool	Includes(const bitVector& other) const;
	virtual	void	ClearAll();

protected:
	vector<unsigned char>	fBitSequence;
	
	// Some utility routines
	unsigned long	ByteNumber(unsigned long idx) const;
	unsigned long	Mask(unsigned long idx) const;
	
private:

};

#endif
