#include "charset.h"

charSet::charSet()
	: bitVector(256)
{
}

charSet::charSet(const char *initialValue)
	: bitVector(256)
{
	while (*initialValue)
   		Add(*initialValue++);
}

charSet::charSet(const charSet& other)
	: bitVector(other)
{
}

void
charSet::Add(const unsigned char aChar)
{
	Set((unsigned long)aChar);
}

void
charSet::MakeEmpty()
{
	// Need to go through and clear all the
	// bits.  The best way would be to set all
	// the array elements to 0.
}

bool
charSet::Includes(const unsigned char aChar) const
{
	return IsSet((unsigned long)aChar);
}

void
charSet::Subtract(const unsigned char aChar)
{
	Clear((unsigned long)aChar);
}

