#ifndef CHARSET_H
#define CHARSET_H

#include "bitvector.h"

//======================================================
// Interface Class: charSet
//
// A charSet is a specialized bitVector.  It keeps track
// of the characters that are selected.  It can be initialized
// with a string, and you can add and remove from it using
// simple Add and Subtract methods.  Utilizing a charSet
// can make routines such as strpbrk go much faster and
// happen in a smaller space.  It might also be good for
// regular expression matching.
//======================================================
class charSet : public bitVector
{
public:			
			charSet();				
			charSet(const char *);				
			charSet(const charSet&);

		void	Add(const unsigned char);
		void	MakeEmpty();
		bool	Includes(const unsigned char) const;
		void	Subtract(const unsigned char);

protected:
private:
};

#endif
