#include "condition.h"
#include <stdio.h>
#include <stdlib.h>

//========================================================
//	Class: ACondition
//
//========================================================

ACondition::ACondition(const char *aName)
{
	// Create the semaphore with a thread count of
	// 0 so all threads will block.
	fSemaphore = create_sem(0,aName);
}

ACondition::ACondition(const ACondition &other)
{
	fSemaphore = other.fSemaphore;
}

ACondition::~ACondition()
{
	delete_sem(fSemaphore);
}

ACondition &
ACondition::operator = (const ACondition &other)
{
	fSemaphore = other.fSemaphore;
	return *this;
}
		
long	
ACondition::InformOne()
{
	long aCount=0;
	
	get_sem_count(fSemaphore, &aCount);
	if (aCount < 0)
		return release_sem_etc(fSemaphore, 1, 0);
	
	return 0;
}

long	
ACondition::InformAll()
{
	long aCount=0;
	//printf("ACondition::InformAll\n");
	
	get_sem_count(fSemaphore, &aCount);
	if (aCount < 0)
		return release_sem_etc(fSemaphore, abs(aCount), 0);

	return 0;
}
	
long	
ACondition::Wait()
{
	return acquire_sem(fSemaphore);
}


