#ifndef DOUBLEENDEDLIST_H
#define DOUBLEENDEDLIST_H

#include "list.h"

template <class T> class doubleEndedList : public list<T>
{
public:
			doubleEndedList();
			doubleEndedList(const doubleEndedList &other);
			
	// from list<T>
	virtual void	Add(T value);
	virtual void	DeleteAll();
	virtual void	RemoveFirst();
	
			void	AddToEnd(T value);
			
protected:
	link<T>		*fLastLink;
	
private:
};



//=========================================================
// 
//=========================================================
template <class T> 
doubleEndedList<T>::doubleEndedList()
	: list<T>()
{
	fLastLink = 0;
}

template <class T> 
doubleEndedList<T>::doubleEndedList(const doubleEndedList &other)
	: list<T>(other)
{
	// we need to find the last link, and assign it.
	// we could use an iterator, but it is simpler to 
	// just iterate over the links ourself.
	fLastLink = fFirstLink;
	if (fLastLink)
		while (LastLink->fNextLink)
			fLastLink = fLastLink->fNextLink;
}

template <class T>
void
doubleEndedList<T>::Add(T value)
{
	if (IsEmpty())
	{
		list<T>::Add(value);
		fLastLink = fFirstLink;
	} else
		list<T>::Add(value);
}

template <class T>
void
doubleEndedList<T>::AddToEnd(T value)
{
	if (fLastLink != 0)
		fLastLink = fLastLink->Insert(value);
	else
		Add(value);
}

template <class T>
void
doubleEndedList<T>::DeleteAll()
{
	list<T>::DeleteAll();
	fLastLink = 0;
}


template <class T>
void
doubleEndedList<T>::RemoveFirst()
{
	list<T>::RemoveFirst();
	if (IsEmpty())
		fLastLink = 0;
}


#endif
