#include "port.h"

port::port(const char *name, const int32 depth)
{
	fPortID = create_port(depth, name);
}


port::port(port_id aPort)
{
	fPortID = aPort;
}

port::~port()
{
	// Destroy port if we are in the team
	// that owns it.
}

ssize_t 
port::Read(int32 *code, void *buffer, size_t buffsize)
{
	if (!code || !buffer)
		return 0;
		
	return read_port(fPortID, code, buffer, buffsize);
}

ssize_t 
port::ReadEtc(int32 *code, void *buff, size_t size, uint32 flags, bigtime_t timeout)
{
	if (!code || !buff)
		return 0;
		
	return read_port_etc(fPortID, code, buff, size, flags, timeout);
}

status_t 
port::Write(int32 code, void *buffer, size_t size)
{
	return write_port(fPortID, code, buffer, size);
}

status_t 
port::WriteEtc(int32 code, void *buff, size_t size,  uint32 flags, bigtime_t timeout)
{
	return write_port_etc(fPortID, code, buff, size, flags, timeout);
}

ssize_t 
port::CurrentBufferSize()
{
	return port_buffer_size(fPortID);
}

ssize_t 
port::CurrentBufferSizeEtc(uint32 flags, bigtime_t timeout)
{
	return port_buffer_size_etc(fPortID, flags, timeout);
}

int32 
port::MessagesWaiting()
{
	return port_count(fPortID);
}

status_t 
port::SetOwner(team_id newTeam)
{
	set_port_owner(fPortID, newTeam);
}

