#ifndef PRIORITYQUEUE_H
#define PRIORITYQUEUE_H

//================================================================
// Protocol Interface: PriorityQueue
//
// A priority queue is a structure that always keeps track of the
// minimum item.  You would use it in cases where you don't care
// about anything other than this minimum item.  Such as which 
// process is to be scheduled next, or which event is next in 
// a simulation.
//================================================================

template <class T>
class priorityQueue
{
public:
	virtual void	Add(T value) = 0;
	
	virtual T		DeleteMin();
	virtual void	RemoveMin()=0;
	virtual T		FindMin()=0;
	
	virtual bool	IsEmpty()=0;
	
protected:
private:

};

template <class T>
T
priorityQueue<T>::DeleteMin()
{
	T result = FindMin();
	RemoveMin();
	return result;
}

#endif
