#ifndef QUEUE_H
#define QUEUE_H

//========================================================
// Protocol Template: queue
//
// The protocol for a common data structure, the queue.
// More specific implementations will utilize various low
// level data structures for actual data storage.
//========================================================

template <class AType> class queue
{
public:
	virtual	void	MakeEmpty() = 0;
	virtual AType	Dequeue() = 0;
	virtual void	Enqueue(const AType val) = 0;
	virtual AType	Front() = 0;
	
	virtual bool	IsEmpty() const = 0;
};

#endif
