#ifndef SEARCH_H
#define SEARCH_H

#include "sort.h"	// For Partition

//==============================================================
// Implementation Template Function: FindElement
//
// This is a quick way to find an element in an array.  It
// utilizes the same techniques as QuickSort does, so it is
// pretty fast.
// You're trying to find the Nth element in a unsorted array
// of elements.  You essentially go through the motions of 
// sorting, but you don't actuall go through the whole array
// if you don't have to, only up to the point where you find
// the element you're looking for.
//==============================================================

template <class T>
T 
FindElement(vector<T>& aVector, unsigned long N,
	unsigned long low, unsigned long high)
{
	unsigned long pivotIndex = (high + low) / 2;

	pivotIndex = Partition(aVector, low, high, pivotIndex);

	if (pivotIndex == N)
		return aVector[N];

	if (N < pivotIndex)
		return FindElement(aVector, N, low, pivotIndex);
	else
   		return FindElement(aVector, N, pivotIndex, high);
}

#endif
